package com.huimv.farm.damsubsidy.controller;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillBuyInfo;
import com.huimv.farm.damsubsidy.entity.vo.BillBuyInfoImageVo;
import com.huimv.farm.damsubsidy.entity.vo.BillBuyInfoVo;
import com.huimv.farm.damsubsidy.mapper.BillBuyInfoMapper;
import com.huimv.farm.damsubsidy.service.IBaseVeterStationService;
import com.huimv.farm.damsubsidy.service.IBillBuyInfoService;
import com.huimv.farm.damsubsidy.service.ISysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 交易信息 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-buy-info")
@CrossOrigin
public class BillBuyInfoController {
    @Autowired
    private IBillBuyInfoService billBuyInfoService;
    @Resource
    private BillBuyInfoMapper billBuyInfoMapper;
    @Resource
    private ISysUserService sysUserService;
    @Resource
    private IBaseVeterStationService baseVeterStationService;

    @PostMapping("/listTransaction")
    public Result listTransaction(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String search = paramsMap.get("search");
        Long id = TokenSign.getMemberIdByJwtToken(httpServletRequest);
        String addressCode = baseVeterStationService.getById(sysUserService.getById(id).getVeterId()).getBriefAddressCode();
        Page<BillBuyInfoVo> page = new Page(Integer.parseInt(pageNum),Integer.parseInt(pageSize));
        Page<BillBuyInfoVo> billBuyInfoPage = billBuyInfoMapper.listTransaction(page,search,addressCode);
        Page<BillBuyInfoImageVo> billBuyInfoVoPage = new Page<>();
        List billBuyInfoImageVoList = new ArrayList();
        for (BillBuyInfo record : billBuyInfoPage.getRecords()) {
            BillBuyInfoImageVo billBuyInfoImageVo = new BillBuyInfoImageVo();
            BeanUtil.copyProperties(record,billBuyInfoImageVo);
            if (ObjectUtil.isNotEmpty(record.getBuyPayGoodsPicUrl())){
                billBuyInfoImageVo.setPages(record.getBuyPayGoodsPicUrl().split(","));
            }
            billBuyInfoImageVoList.add(billBuyInfoImageVo);
        }
        billBuyInfoVoPage.setRecords(billBuyInfoImageVoList);
        billBuyInfoVoPage.setTotal(billBuyInfoPage.getTotal());
        billBuyInfoVoPage.setCountId(billBuyInfoPage.getCountId());
        billBuyInfoVoPage.setCurrent(billBuyInfoPage.getCurrent());
        return new Result(ResultCode.SUCCESS, billBuyInfoVoPage);
    }

    @PostMapping("/addTransaction")
    public Result addTransaction(HttpServletRequest httpServletRequest,
                                 @RequestParam(value = "buyImage1", required = false) MultipartFile buyImage1,
                                 @RequestParam(value = "buyImage2", required = false) MultipartFile buyImage2,
                                 @RequestParam(value = "buyImage3", required = false) MultipartFile buyImage3,
                                 @RequestParam(value = "buyImage4", required = false) MultipartFile buyImage4,
                                 @RequestParam(value = "buyImage5", required = false) MultipartFile buyImage5,
                                 @RequestParam(value = "quarantineImage", required = false) MultipartFile quarantineImage,
                                 @RequestParam("image1") MultipartFile image1,
                                 @RequestParam("image2") MultipartFile image2,
                                 @RequestParam("inspectionNum") String inspectionNum,
                                 @RequestParam("cargoOwner") String cargoOwner,
                                 @RequestParam("ownerPhone") String ownerPhone,
                                 @RequestParam("animalType") String animalType,
                                 @RequestParam("animalNumberUp") String animalNumberUp,
                                 @RequestParam("useTo") String useTo,
                                 @RequestParam("startTran") String startTran,
                                 @RequestParam("reachTran") String reachTran,
                                 @RequestParam("eartags") String eartags,
                                 @RequestParam("seller") String seller,
                                 @RequestParam("sellerId") String sellerId,
                                 @RequestParam("buyer") String buyer,
                                 @RequestParam("buyerId") String buyerId,
                                 @RequestParam("sellerPhone") String sellerPhone,
                                 @RequestParam("buyerPhone")String buyerPhone) throws IOException {
        return billBuyInfoService.addTransaction(httpServletRequest,buyImage1,buyImage2,buyImage3,buyImage4,buyImage5,quarantineImage,image1,image2,inspectionNum,cargoOwner,ownerPhone,animalType,animalNumberUp,useTo,startTran,reachTran,seller,sellerId,buyer,buyerId,eartags,buyerPhone,sellerPhone);
    }

    @PostMapping("/saveTransaction")
    public Result saveTransaction(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.saveTransaction(httpServletRequest,paramsMap);
    }

    @PostMapping("/getLast")
    public Result getLast(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.getLast(httpServletRequest,paramsMap);
    }

    @PostMapping("/listDetail")
    public Result listDetail(HttpServletRequest httpServletRequest,@RequestBody Map<String,String> paramsMap){
        return billBuyInfoService.listDetail(httpServletRequest,paramsMap);
    }



}
