package com.huimv.farm.damsubsidy.controller;


import com.huimv.farm.damsubsidy.common.utils.PdfUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.entity.BillSubsidyBatch;
import com.huimv.farm.damsubsidy.service.IBillSubsidyBatchService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 补贴批次表 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-19
 */
@RestController
@RequestMapping("/bill-subsidy-batch")
@CrossOrigin
public class BillSubsidyBatchController {

    @Autowired
    private IBillSubsidyBatchService billSubsidyBatchService;

    @RequestMapping("/add")
    public Result add(HttpServletRequest httpServletRequest, @RequestBody BillSubsidyBatch billSubsidyBatch) {
        return billSubsidyBatchService.add(httpServletRequest, billSubsidyBatch);
    }
    @RequestMapping("/list")
    public Result list(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return billSubsidyBatchService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return billSubsidyBatchService.listById(httpServletRequest, paramsMap);
    }

    @GetMapping("/printPay")
    public void printPay2(HttpServletResponse response, @RequestParam(name = "ids", required = true) String ids,
                          @RequestParam(name = "batchName", required = true) String batchName,
                          @RequestParam(name = "date", required = true) String date
    ) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("ids", ids);
        map.put("batchName", batchName);
        map.put("date", date);
        billSubsidyBatchService.printHua(map);
        String path = "/opt/subsidy/new_pay.xls";
        PdfUtil.returnPdfStream3(response, path, "花名册");
    }


    @GetMapping("/printCount")
    public void printCount(HttpServletResponse response, @RequestParam(name = "ids", required = true) String ids,
                          @RequestParam(name = "batchName", required = true) String batchName,
                          @RequestParam(name = "date", required = true) String date
    ) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("ids", ids);
        map.put("batchName", batchName);
        map.put("date", date);
        billSubsidyBatchService.printCount(map);
        String path = "/opt/subsidy/new_xian.xls";
        PdfUtil.returnPdfStream3(response, path, "统计表");
    }

    @GetMapping("/printDetail")
    public void printDetail(HttpServletResponse response, @RequestParam(name = "ids", required = true) String ids,
                           @RequestParam(name = "batchName", required = true) String batchName,
                           @RequestParam(name = "date", required = true) String date
    ) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("ids", ids);
        map.put("batchName", batchName);
        map.put("date", date);
        billSubsidyBatchService.printDetail(map);
        String path = "/opt/subsidy/new_detail.xls";
        PdfUtil.returnPdfStream3(response, path, "明细表");
    }
}
