package com.huimv.farm.damsubsidy.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.huimv.farm.damsubsidy.common.utils.LongJsonDeserializer;
import com.huimv.farm.damsubsidy.common.utils.LongJsonSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author author
 * @since 2023-06-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("bill_subsidy_modify")
public class BillSubsidyModify implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 引进奖补数量
     */
    private Integer beforeRewardNum;

    /**
     * 耳标号
     */
    private String beforeEartagNo;

    /**
     * 申报金额
     */
    private BigDecimal beforeApplyMoney;

    /**
     * 修改后引进奖补数量
     */
    private Integer afterRewardNum;

    /**
     * 修改后耳标号
     */
    private String afterEartagNo;

    /**
     * 修改后申报金额
     */
    private BigDecimal afterApplyMoney;

    @JsonSerialize(using = LongJsonSerializer.class)
    @JsonDeserialize(using = LongJsonDeserializer.class)
    private Long updateUserId;

    /**
     * 修改人姓名
     */
    private String updateUserName;

    /**
     * 补贴单id
     */
    private String subsidyId;

    /**
     * 修改时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;


}
